<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;

class ger55000InformacoesAdicionaisController extends \Teknisa\CDP\Controllers\TeknisaCrud {
    protected $ger55000InformacoesAdicionaisService;
    protected $dataSourceName;

    public function __construct($crudService, ParameterBag $parameterBag, $ger55000InformacoesAdicionaisService){
        parent::__construct($crudService, $parameterBag);
        $this->ger55000InformacoesAdicionaisService = $ger55000InformacoesAdicionaisService;
    }

    public function saveInfo(DTO\Request $request, DTO\Response $response){
        try{
            $rows = $request->getRow();
            $infoAdicional = $this->ger55000InformacoesAdicionaisService->saveInfo($rows);
            $response->addDataSet(new DataSet('infoAdicional', [$infoAdicional]));
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function saveDCB(DTO\Request $request, DTO\Response $response){
        try{
            $this->dataSourceNameToSave = 'descdcbprod';
            $rows = $request->getRow();
            $rows['NRDCBPRODUTO'] = bin2hex($rows['NRDCBPRODUTO']);
            $newRequest = new DTO\Request\Row ($rows, '', '', '');
            parent::save($newRequest, $response);
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    
    }
    
    public function saveDCI(DTO\Request $request, DTO\Response $response){
        try{
            $this->dataSourceNameToSave = 'descdciprod';
            $rows = $request->getRow();
            $rows['NRDCIPRODUTO'] = bin2hex($rows['NRDCIPRODUTO']);
            $newRequest = new DTO\Request\Row ($rows, '', '', '');
            parent::save($newRequest, $response);
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    
    }
    
    public function saveCAS(DTO\Request $request, DTO\Response $response){
        try{
            $this->dataSourceNameToSave = 'desccasprod';
            $rows = $request->getRow();
            $rows['NRCASPRODUTO'] = bin2hex($rows['NRCASPRODUTO']);
            $newRequest = new DTO\Request\Row ($rows, '', '', '');
            parent::save($newRequest, $response);
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    
    }
    
    public function saveINCI(DTO\Request $request, DTO\Response $response){
        try{
            $this->dataSourceNameToSave = 'descinciprod';
            $rows = $request->getRow();
            $rows['NRINCIPRODUTO'] = bin2hex($rows['NRINCIPRODUTO']);
            $newRequest = new DTO\Request\Row ($rows, '', '', '');
            parent::save($newRequest, $response);
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    
    }
    
}
?>