<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class Ger11800InspecaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function verificaCDARVINSPEC($CDARVINSPEC){
        try {
         
            $sql = "SELECT CDARVINSPEC, IDORIGINSPEC 
                        FROM INSPECAO WHERE 
                        CDARVINSPEC = :CDARVINSPEC";

            $params = array(
                'CDARVINSPEC'=>$CDARVINSPEC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function verificaCDARVINSPECANTE($CDARVINSPECANTE){
        try {
         
            $sql = "SELECT CDARVINSPEC 
                    FROM INSPECAO WHERE 
                    CDARVINSPEC = :CDARVINSPECANTE 
                    AND IDORIGINSPEC = 'QUA'";

            $params = array(
                'CDARVINSPECANTE'=>$CDARVINSPECANTE
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function verificaDelete($CDARVINSPEC){
        try {
         
            $sql = "SELECT COUNT(CDARVINSPEC) AS TEM_FILHO
                    FROM INSPECAO WHERE 
                    CDARVINSPECANTE = :CDARVINSPEC 
                    AND IDORIGINSPEC = 'QUA'";

            $params = array(
                'CDARVINSPEC'=>$CDARVINSPEC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function verificaDeleteCDINSPECAO($CDINSPECAO){
        try {
         
            $sql = "SELECT CDINSPECAO 
                    FROM VISTOINSPEC 
                    WHERE CDINSPECAO = :CDINSPECAO
                    UNION
                    SELECT CDINSPECAO 
                    FROM ACAOINSPECAO
                    WHERE CDINSPECAO = :CDINSPECAO
                    UNION
                    SELECT CDINSPECAO 
                    FROM DESCINSPECAO 
                    WHERE CDINSPECAO = :CDINSPECAO
                    UNION
                    SELECT CDINSPECAO 
                    FROM CRITAVAPARCI
                    WHERE CDINSPECAO = :CDINSPECAO
                    UNION
                    SELECT CDINSPECAO 
                    FROM RESPOSINSPEC
                    WHERE CDINSPECAO = :CDINSPECAO
                    UNION
                    SELECT CDINSPECAO 
                    FROM INSPECPROD
                    WHERE CDINSPECAO = :CDINSPECAO";

            $params = array(
                'CDINSPECAO'=>$CDINSPECAO
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteArv($NRORG, $CDARVINSPEC,$CDINSPECAO){
        try {
            
            $sql = "DELETE FROM INSPECAO
                    WHERE NRORG = :NRORG AND
                        CDARVINSPEC = :CDARVINSPEC AND
                        CDINSPECAO= :CDINSPECAO 
                        AND IDORIGINSPEC = 'QUA'";

            $params = array(
                'NRORG'=>$NRORG,
                'CDARVINSPEC'=>$CDARVINSPEC,
                'CDINSPECAO'=>$CDINSPECAO
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function updateDesc($NRORG, $CDINSPECAO, $TXDESCINSPEC, $TXDESCINSPEC_CLOB){
        try {
            
            $sql = "UPDATE DESCINSPECAO 
                    SET TXDESCINSPEC = :TXDESCINSPEC, 
                    TXDESCINSPEC_CLOB  = :TXDESCINSPEC_CLOB 
                    WHERE CDINSPECAO = :CDINSPECAO AND 
                    NRORG = :NRORG";

            $params = array(
                'NRORG'=>$NRORG, 
                'CDINSPECAO'=>$CDINSPECAO, 
                'TXDESCINSPEC'=>$TXDESCINSPEC, 
                'TXDESCINSPEC_CLOB'=>$TXDESCINSPEC_CLOB
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
}
