<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Pedidosexpedicao\Entities\Precobase;
use Teknisa\Model\Pedidosexpedicao\Entities\Promoprbase;
use Teknisa\Model\Pedidosexpedicao\Entities\Opcioprbase;
use Teknisa\Model\Pedidosexpedicao\Entities\Itemprebase;
use Teknisa\Model\Eventos\Entities\Prbaseconvidaore;

class cdp02200GrupoDeEquipamentoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function deleteTabelaEquipamento($nrorg,$cdgrupoequipa){
        try {
         
            $sql = "UPDATE EQUIPAPROD
                        SET CDGRUPOEQUIPA = NULL
                        WHERE NRORG = :NRORG AND
                            CDGRUPOEQUIPA = :CDGRUPOEQUIPA";

            $params = array(
                'NRORG'=>$nrorg,
                'CDGRUPOEQUIPA'=>$cdgrupoequipa
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteTabelaGrupo($nrorg,$cdgrupoequipa){
        try {
         
            $sql = "DELETE FROM GRUPOEQUIPA
                    WHERE NRORG = :NRORG AND
                         CDGRUPOEQUIPA = :CDGRUPOEQUIPA";

            $params = array(
                'NRORG'=>$nrorg,
                'CDGRUPOEQUIPA'=>$cdgrupoequipa
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
}