<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class ger55000InformacoesAdicionaisFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function saveInfo($params, $newRow){
        try {
            if($newRow == 0){
                $sql = "INSERT INTO INFADICPROD (CDPRODUTO, CDEANPROD, CDDUNPROD, NRORG)
                        VALUES (:CDPRODUTO,
                                :CDEANPROD,
                                :CDDUNPROD,
                                :NRORG)";
                
                $std = $this->connection->prepare($sql);
                $std->execute($params);
            } else {
                $sql = "UPDATE INFADICPROD
                        SET CDEANPROD = :CDEANPROD,
                            CDDUNPROD = :CDDUNPROD
                        WHERE (CDPRODUTO = :CDPRODUTO
                               AND NRORG = :NRORG)";
                $std = $this->connection->prepare($sql);
                $std->execute($params);
            }
        
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function saveProduto ($params){
        try {
             $sql = "UPDATE PRODUTO
                    SET CDGGREM = :CDGGREM
                    WHERE CDPRODUTO = :CDPRODUTO
                          AND NRORG = :NRORG ";
             $std = $this->connection->prepare($sql);
             $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function selectInfadicprod($params){
        try {
     
        $sql = "SELECT COUNT (CDPRODUTO)
                FROM INFADICPROD
                WHERE (CDPRODUTO = :CDPRODUTO
                       AND NRORG = :NRORG)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();

        
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
}