<?php
/**
 * Created by PhpStorm.
 * User: carinaoliveira
 * Date: 02/12/2014
 * Time: 10:18
 */

namespace Fiscal\Logic\Parametros;

use Estoque\Entities\Parambloqnfafil;
use Geral\Entities\Tipooperac;
use Indeterminado\Entities\Parambloqnfafor;

class ParametrosBloqTpOp {

    //Busca se a filial informada já existe na tabela 'PARAMBLOQNFAFIL'
    public static function buscaFilial ($cdfilial, $nrorg) {

        $sucesso = false;

        try {
            $paramFilial = Parambloqnfafil::findOneByCdfilialAndNrorg($cdfilial, $nrorg);

            if(is_object($paramFilial)) {
                $sucesso = true;
            }

        }
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }

        return $sucesso;

    }

    //Insere na tabela 'PARAMBLOQNFAFIL' todos os tipos de operação de entrada com a filial informada
    public static function insereParamBloqTpOp ($cdfilial, $nrorg, $operador, $data){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            $tiposOperac = Tipooperac::findByIdentrsaidopAndNrorg('E', $nrorg);
            foreach($tiposOperac as $tpOperac) {
                $cdtipooper = $tpOperac->getCdtipooper();

                $paramFilial = new Parambloqnfafil();

                $paramFilial->setCdfilial($cdfilial);
                $paramFilial->setIdentrsaidop('E');
                $paramFilial->setCdtipooper($cdtipooper);
                $paramFilial->setIdliberatpopfil('S');
                $paramFilial->setIdexigeaf('N');

                $paramFilial->setNrorg($nrorg);
                $paramFilial->setIdativo('S');
                $paramFilial->setDtultatu($data);
                $paramFilial->setCdoperultatu($operador);
                $paramFilial->setNrorgultatu($nrorg);
                $paramFilial->setDtinclusao($data);
                $paramFilial->setCdoperinclusao($operador);
                $paramFilial->setNrorginclusao($nrorg);

                $paramFilial->persist();
            }

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

    //
    //
    //
    //Busca se o fornecedor informado já existe na tabela 'PARAMBLOQNFAFOR'
    public static function buscaFornecedor($cdfornecedor, $nrorg) {

        $sucesso = false;

        try {
            $paramFornecedor = Parambloqnfafor::findOneByCdfornecedAndNrorg($cdfornecedor, $nrorg);

            if(is_object($paramFornecedor)) {
                $sucesso = true;
            }

        }
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }

        return $sucesso;

    }

    //Insere na tabela 'PARAMBLOQNFAFOR' todos os tipos de operação de entrada com o fornecedor informado
    public static function insereParamBloqTpOpForneced ($cdfornecedor, $nrorg, $operador, $data){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            $tiposOperac = Tipooperac::findByIdentrsaidopAndNrorg('E', $nrorg);
            foreach($tiposOperac as $tpOperac) {
                $cdtipooper = $tpOperac->getCdtipooper();

                $paramFornecedor = new Parambloqnfafor();

                $paramFornecedor->setCdforneced($cdfornecedor);
                $paramFornecedor->setIdentrsaidop('E');
                $paramFornecedor->setCdtipooper($cdtipooper);
                $paramFornecedor->setIdliberatpopfor('S');

                $paramFornecedor->setNrorg($nrorg);
                $paramFornecedor->setIdativo('S');
                $paramFornecedor->setDtultatu($data);
                $paramFornecedor->setCdoperultatu($operador);
                $paramFornecedor->setNrorgultatu($nrorg);
                $paramFornecedor->setDtinclusao($data);
                $paramFornecedor->setCdoperinclusao($operador);
                $paramFornecedor->setNrorginclusao($nrorg);

                $paramFornecedor->persist();
            }

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

} 