/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8550_SUPSTPO.sql

Descrio:
Atualiza a tabela de itens da apurao de preos

Criao:
09/01/2004 - Joo Fernando dos Reis Corra
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
            O.NAME = 'ATUALIZA_ITMAPUR' AND
            TYPE = 'P'                  AND
            U.UID = O.UID               AND
            U.NAME = USER)
   DROP PROCEDURE ATUALIZA_ITMAPUR
GO

CREATE
PROCEDURE ATUALIZA_ITMAPUR
   @P_CDCENTCMP   VARCHAR(4),
   @P_NRSEQAPUR   VARCHAR(10),
   @P_CDPRODUTO   VARCHAR(10),
   @P_CDMARCA     VARCHAR(5),
   @P_CDFORNECED  VARCHAR(21),
   @P_CDREGIAO    VARCHAR(5),
   @P_NRCOLEPRECO VARCHAR(10)
AS
   DECLARE @V_CDFILIAP     VARCHAR(4);
   DECLARE @V_CDFORNITMAP  VARCHAR(21);
   DECLARE @V_CDPRODITMAP  VARCHAR(10);

   DECLARE @V_IDEMITAFDES  VARCHAR(1);
   DECLARE @V_CDEMPRESA    VARCHAR(2);
   DECLARE @V_CDEMITENTE   VARCHAR(4);

   DECLARE @V_DSPZOPGTCONC VARCHAR(1000);

   DECLARE @V_IDPRODWEB    VARCHAR(1);
   DECLARE @V_IDAFOPERLOG  VARCHAR(1);

BEGIN
   DECLARE C_ITMAPUR CURSOR FOR
     (SELECT
         CDFILIAP,
         CDFORNITMAP,
         CDPRODITMAP
      FROM
         ITMAPURPREC
      WHERE
         (CDCENTITMAP = @P_CDCENTCMP)   AND
         (NRSEQITMAP  = @P_NRSEQAPUR)   AND
         (CDPRODITMAP = @P_CDPRODUTO)   AND
         (CDMARCITMAP = @P_CDMARCA)     AND
         (CDFORNITMAP = @P_CDFORNECED)  AND
         (CDREGITMAP  = @P_CDREGIAO)    AND
         (NRCOLEITMAP = @P_NRCOLEPRECO));
   OPEN C_ITMAPUR;
   FETCH NEXT FROM C_ITMAPUR INTO
      @V_CDFILIAP,
      @V_CDFORNITMAP,
      @V_CDPRODITMAP
   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_CDEMITENTE = TEKNISA.EMITENTE(@V_CDFILIAP, @V_CDPRODITMAP, @V_CDFORNITMAP);

      SET @V_IDPRODWEB = 'N';
      SELECT
         @V_IDPRODWEB = ISNULL(MAX(PARAMPRODSUP.IDPRODWEB), 'N')
      FROM
         PARAMPRODSUP
      WHERE
         (CDFILIAL   = @V_CDFILIAP)    AND
         (CDPRODUTO  = @V_CDPRODITMAP) AND
         (CDFORNECED = @V_CDFORNITMAP);

      SET @V_IDAFOPERLOG = 'X';
      SELECT
         @V_IDAFOPERLOG = ISNULL(MAX('2'),'X')
      FROM
         PARAMPRODSUP
      WHERE
         (CDFILIAL   = @V_CDFILIAP)    AND
         (CDPRODUTO  = @V_CDPRODITMAP) AND
         (CDFILIOPELOG IS NOT NULL);

      UPDATE ITMAPURPREC SET
         ITMAPURPREC.IDTPFORPGTAP  = ITEMCOLE.IDTPFOPGTCOL,
         ITMAPURPREC.CDTIPCOBAP    = ITEMCOLE.CDTIPCOB,
         ITMAPURPREC.IDTIPOFRETAP  = ITEMCOLE.IDTIPFREITM,
         ITMAPURPREC.CDFORMPGTOAP  = ITEMCOLE.CDFORMPGTO,
         ITMAPURPREC.NRPARCPGTOAP  = ITEMCOLE.NRPARCPGTCOL,
         ITMAPURPREC.NRDIAPGFIAP   = ITEMCOLE.NRDIAPGFXCOL,
         ITMAPURPREC.IDULTDIAPGTAF = ITEMCOLE.IDUTDIAPGCOL,
         ITMAPURPREC.DSPZOPGTCOAP  = ITEMCOLE.DSPZOPGTCONC,
         ITMAPURPREC.CONCKEYAP     = (@V_CDFILIAP + ITEMCOLE.CDFORNECED +
                                      SUBSTRING(@V_CDEMITENTE, 3, 2) +
                                      ISNULL(ITEMCOLE.IDTPFOPGTCOL,'') +
                                      ISNULL(ITEMCOLE.CDTIPCOB, '') +
                                      ISNULL(ITEMCOLE.IDTIPFREITM, '')  +
                                      ISNULL(ITEMCOLE.CDFORMPGTO, '') +
                                      ISNULL(CONVERT(VARCHAR, ITEMCOLE.NRPARCPGTCOL), '') +
                                      ISNULL(CONVERT(VARCHAR, ITEMCOLE.NRDIAPGFXCOL), '') +
                                      ISNULL(ITEMCOLE.IDUTDIAPGCOL, '') +
                                      SUBSTRING(@V_CDEMITENTE, 1, 1) +
                                      @V_IDPRODWEB +
                                      @V_IDAFOPERLOG),
         ITMAPURPREC.CDSEGMARCCOL  = ITEMCOLE.CDSEGMARCCOL,
         ITMAPURPREC.VRPERDESIAP   = ITEMCOLE.VRPERDESITM,
         ITMAPURPREC.VRPRECUNIAP   = ITEMCOLE.VRPRECUNIITM
      FROM
         ITEMCOLE
      WHERE
         (ITMAPURPREC.CDCENTITMAP = @P_CDCENTCMP)   AND
         (ITMAPURPREC.NRSEQITMAP  = @P_NRSEQAPUR)   AND
         (ITMAPURPREC.CDPRODITMAP = @P_CDPRODUTO)   AND
         (ITMAPURPREC.CDMARCITMAP = @P_CDMARCA)     AND
         (ITMAPURPREC.CDFORNITMAP = @P_CDFORNECED)  AND
         (ITMAPURPREC.CDREGITMAP  = @P_CDREGIAO)    AND
         (ITMAPURPREC.NRCOLEITMAP = @P_NRCOLEPRECO) AND
         (ITEMCOLE.CDFILIAL       = @P_CDCENTCMP)   AND
         (ITEMCOLE.CDPRODUTO      = @P_CDPRODUTO)   AND
         (ITEMCOLE.CDMARCA        = @P_CDMARCA)     AND
         (ITEMCOLE.CDFORNECED     = @P_CDFORNECED)  AND
         (ITEMCOLE.CDREGIAO       = @P_CDREGIAO)    AND
         (ITEMCOLE.NRCOLEPRECO    = @P_NRCOLEPRECO)
      FETCH NEXT FROM C_ITMAPUR INTO
         @V_CDFILIAP,
         @V_CDFORNITMAP,
         @V_CDPRODITMAP
   END;
   CLOSE C_ITMAPUR;
   DEALLOCATE C_ITMAPUR;
END
GO

